% domains
boolean(true).
boolean(false).

% fluents
fluent(at(start)).
fluent(on(belmont)).
fluent(on(western)).
fluent(on(ashland)).
fluent(traffic_bad).
fluent(at(evanston)).

domain(at(start),V) :- boolean(V).
domain(on(belmont),V) :- boolean(V).
domain(on(western),V) :- boolean(V).
domain(traffic_bad,V) :- boolean(V).
domain(at(evanston),V) :- boolean(V).

% actions and effects
action(goto_western_at_belmont).
executable(goto_western_at_belmont, [eq(at(start),true)]).
causes(goto_western_at_belmont, eq(on(western),true), []).
causes(goto_western_at_belmont, eq(on(belmont),true), []).
causes(goto_western_at_belmont, eq(at(start),false), []).

action(check_on_western).
executable(check_on_western, []).
determines(check_on_western, on(belmont)).

action(check_traffic).
executable(check_traffic, []).
determines(check_traffic, traffic_bad).

action(take_belmont).
executable(take_belmont, [eq(traffic_bad,true),eq(on(belmont),true)]).
causes(take_belmont, eq(on(ashland),true), []).
causes(take_belmont, eq(on(western),false), []).

action(take_ashland).
executable(take_ashland, [eq(on(ashland),true)]).
causes(take_ashland, eq(at(evanston),true), []).

action(take_western).
executable(take_western, [eq(traffic_bad,false),eq(on(western),true)]).
causes(take_western, eq(at(evanston),true), []).

initially([eq(at(start),true),
           eq(on(western),false),
           eq(on(belmont),false),
           eq(on(ashland),false),
           eq(at(evanston),false)]).

sgoal([eq(at(evanston),true)]).
