package(p1).
package(p2).

location(rug).
location(toilet).

boolean(true).
boolean(false).

% fluents and domains
fluent(loc(P)):- package(P).
fluent(has_bomb(P)):- package(P).
fluent(disarmed).
fluent(wet(P)):- package(P).

% non-inertial fluents
noninertial(disarmed).

domain(loc(P),L) :- package(P), location(L).
domain(has_bomb(P),V) :- package(P), boolean(V).
domain(disarmed,V) :- boolean(V).
domain(wet(P),V) :- package(P), boolean(V).

% actions and effects
action(xray(P)):- package(P).
executable(xray(P), []):- package(P).
determines(xray(P), has_bomb(P)):- package(P).

action(move_from_rug_to_toilet(P)):- package(P).
executable(move_from_rug_to_toilet(P), [eq(loc(P),rug)]):- package(P).
causes(move_from_rug_to_toilet(P),eq(loc(P),toilet),[]):- package(P).

action(dunk(P)):- package(P).
executable(dunk(P), [eq(loc(P),rug)]):- package(P).
causes(dunk(P), eq(wet(P),true), []):- package(P).
causes(dunk(P), eq(has_bomb(P),false), [eq(has_bomb(P),true)]):- package(P).

% statical laws
% at least one package has bomb
caused(eq(disarmed,false),[eq(has_bomb(P),true)]) :- package(P).
caused(eq(disarmed,true),[eq(has_bomb(p1),false),eq(has_bomb(p2),false)]).

% initial state
initially([eq(loc(p1),rug),
           eq(loc(p2),rug)]).

% goal
sgoal([eq(disarmed,true)]).
