% length = 4, level = 3

car(car_1).
car(car_2).

location(loc_1).
location(loc_2).
boolean(true).
boolean(false).

fluent(pkg_location).
fluent(available(C)) :- car(C).
fluent(at(L)) :- location(L).
fluent(happy).

domain(pkg_location,V) :- location(V).
domain(available(C),V) :- car(C), boolean(V).
domain(happy,V) :- boolean(V).
domain(at(L),V) :- boolean(V).

action(ask_about_package).
executable(ask_about_package, []).
determines(ask_about_package, pkg_location).

action(ask_about_car(C)) :- car(C).
executable(ask_about_car(C), []) :- car(C).
determines(ask_about_car(C), available(C)) :- car(C).

action(drive(C,L)):- car(C), location(L).
executable(drive(C,L), [eq(available(C),true)]):- action(drive(C, L)).
causes(drive(C,L), eq(at(L),true), []):- action(drive(C, L)).
causes(drive(C,L), eq(available(C),false), []):- action(drive(C, L)).

% statical laws
caused(eq(happy,true), [eq(pkg_location,L), eq(at(L),true)]) :- location(L).

caused(eq(available(car_1),true), [eq(available(car_2),false),eq(happy,false)]).
caused(eq(available(car_2),true), [eq(available(car_1),false),eq(happy,false)]).

caused(eq(available(car_1),false), [eq(available(car_2),true)]).
caused(eq(available(car_2),false), [eq(available(car_1),true)]).

% initial state
initially([eq(happy,false)]).

% goal
sgoal([eq(happy,true)]).

