boolean(true).
boolean(false).

% fluents
fluent(foot_broken).
fluent(kick_breaks_foot).
fluent(kick_breaks_lock).
fluent(lock_intact).
fluent(locked).
fluent(open).

domain(foot_broken,V) :- boolean(V).
domain(kick_breaks_foot,V) :- boolean(V).
domain(kick_breaks_lock,V) :- boolean(V).
domain(lock_intact,V) :- boolean(V).
domain(locked,V) :- boolean(V).
domain(open,V) :- boolean(V).

% actions and effects
action(kick).
executable(kick, []).
causes(kick, eq(foot_broken,true), [eq(kick_breaks_foot,true)]).
causes(kick, eq(lock_intact,true), [eq(kick_breaks_lock,true)]).
  
action(examine_lock).
executable(examine_lock, []).
determines(examine_lock, locked).
  
action(pick).
executable(pick, [eq(lock_intact,true), eq(locked,true)]).
causes(pick, eq(locked,false), []).

action(open_door).
executable(open_door, [eq(locked,false)]).
causes(open_door, eq(open,true), []).

% initial state
initially([eq(lock_intact,true),
           eq(foot_broken,false),
           eq(open,false)]).

% goal
sgoal([eq(open,true)]).
