%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              BOMB IN THE TOILET                            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% packages
package(1).
package(2).
package(3).
package(4).
package(5).

boolean(true).
boolean(false).

% actions
action(dunk(X)):- package(X).
action(detect_metal(X)) :- package(X).
action(sniff(X)) :- package(X).

% fluents
fluent(in(X)):- package(X).
fluent(armed).
fluent(clogged).

noninertial(armed).

domain(in(X),V) :- package(X), boolean(V).
domain(armed,V) :- boolean(V).
domain(clogged,V) :- boolean(V).

% effects
causes(dunk(X), eq(in(X),false), [eq(in(X),true)]) :- package(X).
causes(dunk(X), eq(clogged,true), [eq(in(X),false)]) :- package(X).

determines(detect_metal(X), in(X)) :- package(X).
determines(sniff(X), in(X)) :- package(X).

% preconditions
executable(dunk(X), [neq(clogged,true)]):- package(X).
executable(detect_metal(X), []) :- package(X).
executable(sniff(X), []) :- package(X).

% initially: one of packages has bomb
initially([eq(armed,true),eq(clogged,false)]).

% static laws
caused(eq(armed,true), [eq(in(X),true)]) :- package(X).
caused(eq(armed,false), [eq(in(1),false), eq(in(2),false), 
                        eq(in(3),false), eq(in(4),false), eq(in(5),false)]).

caused(F,L):- 
       member(F, [eq(in(1),true), eq(in(2),true), eq(in(3),true), 
                 eq(in(4),true), eq(in(5),true)]),
       select(F, [eq(in(1),true), eq(in(2),true), eq(in(3),true), 
                 eq(in(4),true), eq(in(5),true)], Q),
       neq_I(Q, L).

neq_I([],[eq(armed,true)]).

neq_I([eq(H,true)|L],[eq(H,false)|L1]):- neq_I(L,L1).

caused(neq(in(J),true), [eq(in(I),true)]):- package(I), package(J), I =\= J.

% goal
sgoal([neq(armed,true),neq(clogged,true)]).
