illness(1).
illness(2).
illness(3).
illness(4).
illness(5).
illness(none).

color(red).
color(blue).
color(white).

boolean(true).
boolean(false).

cure(X) :- illness(X), neq(X,none).

% fluents
fluent(illness).
fluent(dead).
fluent(color).
fluent(tcd).
fluent(bsd).
fluent(hc).

domain(illness,V) :- illness(V).
domain(dead,V) :- boolean(V).
domain(color,V) :- color(V).
domain(tcd,V) :- boolean(V).
domain(bsd,V) :- boolean(V).
domain(hc,V) :- boolean(V).

% actions
action(inspect).
action(analyze_blood).
action(stain).
action(blood_sample).
action(medicate(X)) :- cure(X).

% executability conditions
executable(inspect, [eq(dead,false),eq(tcd,true)]).  
executable(analyze_blood, [eq(dead,false),eq(bsd,true)]).
executable(stain, [eq(dead,false)]).
executable(blood_sample, [eq(dead,false)]).
executable(medicate(X), [eq(dead,false)]) :- cure(X).

% effects: nonsensing actions
causes(stain, eq(tcd,true), []).
causes(blood_sample, eq(bsd,true), []).
causes(medicate(X), eq(illness,none), [eq(illness,X)]) :- cure(X).
causes(medicate(X), eq(dead,true), [neq(illness,X)]) :- cure(X).
causes(medicate(X), eq(dead,true), [eq(illness,none)]) :- cure(X).

% sensing actions
determines(inspect,color).
determines(analyze_blood,hc).

% statical causal laws
caused(neq(illness,1), [eq(color,blue)]).
caused(neq(illness,2), [eq(color,blue)]).
caused(neq(illness,5), [eq(color,blue)]).

caused(neq(illness,3), [eq(color,red)]).
caused(neq(illness,4), [eq(color,red)]).
caused(neq(illness,5), [eq(color,red)]).

caused(neq(illness,1), [eq(color,white)]).
caused(neq(illness,2), [eq(color,white)]).
caused(neq(illness,3), [eq(color,white)]).
caused(neq(illness,4), [eq(color,white)]).

caused(neq(illness,2), [eq(hc,true)]).
caused(neq(illness,4), [eq(hc,true)]).

caused(neq(illness,1), [neq(hc,true)]).
caused(neq(illness,3), [neq(hc,true)]).
caused(neq(illness,5), [neq(hc,true)]).

caused(neq(color,blue), [neq(illness,3), neq(illness,4), neq(illness,none)]).
caused(neq(color,red), [neq(illness,1), neq(illness,2), neq(illness,none)]).
caused(neq(color,white), [neq(illness,5), neq(illness,none)]).

% initial state
initially([eq(dead,false),neq(illness,none),neq(illness,4),neq(illness,5)]).

% goal
sgoal([eq(illness,none),eq(dead,false)]).
